#!/usr/bin/perl

while(<>)
{
  if (/^Kaccess hash -o \/etc\/mail\/access/)
  {
    print;
    print "\n# Pop-before-smtp secondary access hash\n";
    print "Kpopauth hash -a\<MATCH\> /etc/mail/popip.db\n";
  }
  elsif (/550 Relaying denied\"/)
  {
    s/550 ([^\"]+)/550 Relaying denied.  Please check your mail first./;
    print;
  }
  elsif (/^SLocal_check_rcpt/)
  {
  print;
  print <<EOF;
# Put the address into cannonical form (even if it doesn't resolve to an MX).
R\$\*			\$: \$>Parse0 $>3 \$1
R\$\* < \$\* > \$\*		\$: \$1 < \$2 . > \$3
R\$\* < \$\* . . > \$\*	\$1 < \$2 . > \$3
# Test against pop-before-relay hash
R\$\*			\$: < \$\&\{client_addr\} >
R< \$\* >			\$(popauth \$1 \$)
R\$\* < MATCH >		\$\#OK

EOF
  }
  else
  {
    print;
  }
}
