#!/usr/bin/perl
#
# Copyright 1998-2000, Cobalt Networks, Inc
# All rights reserved

require Cobalt::BandWidth;
require Cobalt::Util;
import  Cobalt::Util qw[ MSG_get_ui ];
require CGI;

$Eicon    = "<IMG SRC=\"/.cobalt/images/bang\" ALIGN=\"center\">";
$URL_mod  = "/cgi-bin/.cobalt/bw/bwMod.cgi";
$URL_list = "/cgi-bin/.cobalt/bw/bwList.cgi";

#$locale = Cobalt::Locale->getByHTTPHeader($ENV{'HTTP_ACCEPT_LANGUAGE'});
#if ($locale) { $ENV{'LANGUAGE'}=$locale->getLocale }

$query = new CGI;
$query->import_names('Q');

$spacer       = '<FONT COLOR="#ffffff">&nbsp;</FONT>';
$help_ipaddr  = MSG_get_ui("bw_help_ipaddr");
$help_bwlimit = MSG_get_ui("bw_help_bwlimit");
$help_invalid = MSG_get_ui("bw_help_invalid");
$str_nofreeip = MSG_get_ui("bw_help_nofreeip");
$str_ipaddr   = MSG_get_ui("ipAddr");
$str_bwlimit  = MSG_get_ui("bw_bwlimit");
$str_bwMod    = MSG_get_ui("bw_mod");
$str_saving   = MSG_get_ui("savingWait");
$str_save     = MSG_get_ui("saveChanges");
$str_cancel   = MSG_get_ui("cancel");
$str_help     = MSG_get_ui("help");

if ($Q::page eq 'bwmod')
{
    $ret = Cobalt::BandWidth::bw_setip(bwlimit => $Q::bwlimit, ip => $Q::ipaddr);
    if ($ret =~ /^2/) {	print "Location: ${URL_list}\n\n" }
    else              { print "Location: ${URL_mod}\?info=", $Eicon, substr($ret,4), "\n\n" }
    exit 1;
}

unless ($Q::ipaddr)
{
    print "Location: ${URL_list}\n\n";
}

$bwlimit = Cobalt::BandWidth::bw_getip($Q::ipaddr);
$javascript = <<END;
top.showInfo( '$Q::info' );

var help_ipaddr='$help_ipaddr';
var help_bwlimit='$help_bwlimit';
var help_invalid='$help_invalid';

function trySubmit() {
    var f=document.forms[ 0 ];
    if( f.bwlimit.value < 10 || f.bwlimit.value.length==0 ) {
	top.showInfo( help_invalid );
    }
    else {
	top.showInfo( '<IMG SRC="/.cobalt/images/saving"> ${str_saving}', 0 );
	return true;
    }
    return false;
}
END

print $query->header(-expires => '-1d');
print '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">';
print $query->start_html(-title => $str_bwMod, -BGCOLOR => "#ffffff", -script => $javascript);
print <<END;

<CENTER>
<FORM ACTION="${URL_mod}" METHOD="POST" ENCTYPE="application/x-www-form-urlencoded" onSubmit="return trySubmit();">
<TABLE BORDER="1" CELLSPACING="0" WIDTH="320">
  <TR>
    <TD COLSPAN="3" BGCOLOR="#6666CC" ALIGN="CENTER"><FONT COLOR="#ffffff"><B>${str_bwMod}</B></FONT></TD>
  </TR>
  <TR>
    <TD WIDTH="26"><CENTER><A HREF="javascript: top.showInfo( help_ipaddr );" onMouseOver="status='${str_help}'; top.showInfo( help_ipaddr ); return true;"><IMG SRC="/.cobalt/images/smallest_help_but" BORDER="0" ALIGN="BOTTOM"></A></CENTER></TD>
    <TD WIDTH="130" ALIGN="LEFT" VALIGN="MIDDLE" NOWRAP>${spacer}${str_ipaddr}</TD>
    <TD WIDTH="150" ALIGN="LEFT" VALIGN="MIDDLE" NOWRAP>${Q::ipaddr}</TD>
  </TR>
  <TR>
    <TD><CENTER><A HREF="javascript: top.showInfo( help_bwlimit );" onMouseOver="status='${str_help}'; top.showInfo( help_bwlimit ); return true;"><IMG SRC="/.cobalt/images/smallest_help_but" BORDER="0" ALIGN="BOTTOM"></A></CENTER></TD>
    <TD ALIGN="LEFT" VALIGN="MIDDLE" NOWRAP>${spacer}${str_bwlimit}</TD>
    <TD ALIGN="LEFT" VALIGN="MIDDLE" NOWRAP><INPUT TYPE="TEXT" NAME="bwlimit" MAXLENGTH="10" SIZE="10" VALUE="${bwlimit}"></TD>
  </TR>
</TABLE>

<BR>

<A HREF="javascript: if( trySubmit() ) document.forms[ 0 ].submit();" onMouseOver="status='${str_save}'; return true;">
  <IMG SRC="/.cobalt/images/save_but" BORDER="0">
</A>
<A HREF="${URL_list}" onMouseOver="status='${str_cancel}'; return true;">
  <IMG SRC="/.cobalt/images/cancel_but" BORDER="0">
</A>

<INPUT TYPE="HIDDEN" NAME="ipaddr" SIZE="-1" VALUE="${Q::ipaddr}">
<INPUT TYPE="HIDDEN" NAME="page" SIZE="-1" VALUE="bwmod">

</FORM>
</CENTER>
END

print $query->end_html;

1;
